# YData Package 

# Production License Agreement

Before you accept this Production License Agreement (“Agreement”), read these terms carefully. By accepting this Agreement or using YData Software (as defined below), you are agreeing to be bound by and are becoming a party to this Agreement. You represent and warrant that you have the authority to enter into this Agreement on behalf of any group or entity you represent, and you have the authority to bind such entity to this Agreement, in which case “you” means such entity.

You hereby covenant to ensure that all users that gain access to the YData software from you are bound by this Agreement. If you do not agree to the terms set out in this Agreement, do not use the YData Software.

Our [Privacy Policy](https://ydata.ai/privacy-policy) explains how we collect and use personal information. Although it is not part of these Terms, it is an important document that you should read.

This Agreement limits class action claims and requires arbitration of disputes.

Definitions  
*YData* means YData Labs, Inc., a Delaware corporation.

*YData Software* means YData packages, including but not limited to ydata, ydata-profiling and ydata-synthetic, Fabric  and fabric-sdk, and any other YData proprietary computer programs that are made available to you under this Agreement, in object code and/or source code forms, as applicable, (including updates which may be provided in YData’s sole discretion).

*Documentation* means the user guide, help information and/or other documentation generally provided by YData to users of the YData Software.

*Site* means [https://ydata.ai/](https://ydata.ai/) and its subdomains.

*Term* means, collectively, the Initial Term and each Renewal Term, as defined below.

Binding Agreement & Changes  
*Binding Agreement*: These Terms are a legal agreement between you (together with the group or entity that you represent) and YData, establishing the terms and conditions under which you can access and use the YData Software.

*Changes*: YData reserves the right to revise this Agreement in its sole discretion at any time by posting revised terms on the Site. Revisions to this Agreement are effective and binding on you upon the commencement of the Renewal Term.

## **Using Our Software**

What you can do: Subject to this Agreement and the payment of applicable Fees (defined below), YData grants you a nonexclusive, non transferable, non sublicensable right and license to use the YData Software and the Documentation, during the Term.

What you cannot do: Any other use of the YData Software for commercial purposes is expressly prohibited under this license. That includes, but is not limited to the following usage scenarios:

* (a) Enabling a third party to use the YData Software is prohibited. That includes, but is not limited to, the following scenarios:  
  * (a.1) Integrating the YData Software in a Software as a Service application is prohibited.  
  * (b.1) Integrating the YData Software into a solution that is deployed in a third party environment is prohibited.  
  * (c.2) Copying, distributing, disclosing or sharing with any third party the models generated using the YData Software, or enabling a third party to model or sample data using the software, is prohibited.  
  * (d.3) Using the YData Software to generate or sample a model in a third party environment is prohibited.

Important Requirements & Restrictions:

1. Single Product. The YData Software is licensed as a single product, and you may not separate or use its component parts.  
2. Limited Users. Access to the YData Software is strictly limited to the user per license purchased. Use of the YData Software by additional users requires the purchase of an add-on.  
3. Use Restrictions. Except as specifically permitted in this Agreement, you may not directly or indirectly:  
   * disassemble, decompile, reverse engineer or use any other means to attempt to discover any source code or underlying ideas, algorithms or organization of the YData Software (except and only to the extent that these restrictions are expressly prohibited by applicable statutory law);  
   * encumber, loan, lease, rent, sublicense, transfer, repackage or distribute any YData Software, or use the YData Software for the benefit of any third party (e.g., service bureau arrangement);  
   * copy, create derivative works of or otherwise modify any YData Software or Documentation;  
   * use or allow the transfer, transmission, export or re-export of all or any part of the YData Software (or any product thereof) in violation of any export control laws or regulations of the United States or any other relevant jurisdiction; or  
   * use any Confidential Information or any component of the YData Software or Documentation to create any software or documentation that is similar to or competes with any YData Software.  
4. License Keys. You acknowledge that the YData Software may contain codes or require license keys that detect or prevent unauthorized use of, or disable, the YData Software in the case you do not use the license according to this Agreement.  
5. Limited Support and Updates. YData will offer support through an established public ticketing system, available on [this page](https://support.ydata.ai/). YData will use commercially reasonable efforts to respond to up to 10 support inquiries per month within 3 to 5 business days. YData will not respond to emails sent to individuals including private emails or DMs sent on Discord.  
6. Upgrade Requests. YData reserves the right to provide additional versions of the YData Software, including bug fixes and new features. YData reserves the right to request that you upgrade the licensed software package to the latest version if deemed necessary. Such requests may be required to ensure security, address critical issues, or capture additional Usage Metrics (as defined below).  
7. Usage Metrics. The YData Software may transmit to YData, on a periodic basis, diagnostic data relating to the YData Software, including, without limitation, system performance, capacity usage, system faults, and other information of a similar nature (collectively, “Usage Metrics”). In addition to the automatic transmission of Usage Metrics, you may choose to provide additional data to YData for technical analysis or other use in connection with the YData Software. YData may use the Usage Metrics to provide YData Software, troubleshoot the YData Software and to enhance, improve, and develop its products. Usage Metrics, in anonymized form, shall be deemed YData’s Confidential Information.  
8. Audit Rights: Upon two weeks written notice, YData may audit your use of the YData Software to verify your compliance with this Agreement. You must make their systems and all applicable books, records and transaction logs available for such inspection and copying during normal business hours, at your principal place of business or other locations where the YData Software is used. Any audit will be at YData’s expense.  
9. Third parties: You shall not permit any third party to do any of the foregoing.

You will promptly notify YData in writing of any unauthorized use, reproduction or distribution of any YData Software.

## **Term and Termination**

Term: The initial term of this agreement shall commence from the data of purchase of a license and will continue for the period specified during the purchase (“Initial Term”). Upon expiration, this Agreement shall automatically renew (the “Automatic Renewal”) for successive terms of equal length to the Initial Term (each a “Renewal Term”), unless an alternative term length is expressly designated during the purchasing process. To terminate the Automatic Renewal, either party must provide write notice to the other party at least fifteen (15) days prior to the end of the Initial Term or any Renewal Term by filling out [this form](https://ydata.ai/contact-us). Following the termination or expiration of the Term under this Agreement, all use of the YData Software and associated Documentation must cease immediately.

Termination: YData may terminate your access to the YData Software, in its sole discretion, for any reason and at any time, upon electronic notice to you at your registered email address, including, without limitation, for any violation of this Agreement or failure of your payment to process upon Automatic Renewal. You agree that YData is not liable to you or any third party for any termination of your access to the YData Software. You may terminate this Agreement at any time by ceasing to use the YData Software and providing notice to YData, at which point the Automatic Renewal will be terminated as well.

## 

## **Fees and Payment**

Fees: You shall pay YData the fees set forth on the Site that correspond to the license you are purchasing (“Fees”). YData may charge your payment method for all Fees due during the Initial Term and any Renewal Term. YData reserves the right to revise the Fees and payment terms with at least sixty (60) days prior notice to you, and such changes will be effective upon commencement of your next Renewal Term.

No Refunds: Except as set forth in this Agreement, required by law, or otherwise agreed upon in writing by both parties, YData shall have no obligation to provide refunds, and all Fees are non-refundable.

Third Party Payment Provider: YData may use a third party payment service to bill you through an online account. By submitting payment account information, you grant YData the right to store and process such information with the third party payment service and agree that YData will not be responsible for any failures of the third party to adequately protect such information. The processing of payments will be subject to the terms, conditions and privacy policies of such third party payment service in addition to this Agreement. You acknowledge that YData may change the third party payment service and move such information to other service providers that encrypt the information using secure socket layer technology (SSL) or other comparable security technology. All information that you provide to the third party payment processor, including credit card information or payment account information, is subject to such third party’s Privacy Policy.

Taxes: All payments and Fees required by this Agreement are exclusive of federal, state, local and foreign taxes, duties, tariffs, levies, withholdings and similar assessments (including without limitation, sales taxes, use taxes and value added taxes), and you agree to bear and be responsible for the payment of all such charges, excluding only taxes based upon YData’s net income.

## **Confidentiality**

Definition: “Confidential Information” means all trade secrets, know-how, inventions, developments, software and other financial, business or technical information of you or YData (or any of YData’s licensors, suppliers, affiliates, or other customers) that is disclosed by or for you or YData or that is otherwise learned or accessed by you or YData in the performance of this Agreement. Each party disclosing Confidential Information hereunder is a “Discloser,” and each party receiving Confidential Information hereunder is a “Recipient.” Confidential Information does not include any information that a Recipient can demonstrate is (a) rightfully furnished to Recipient without restriction by a third party without breach of any separate obligation to Discloser, (b) generally available to the public without breach of this Agreement, or (c) independently developed by Recipient without reliance on information of Discloser, as evidenced by prior written records.

Non-use and Nondisclosure Obligations: Except for the specific rights granted by this Agreement, Recipient may not possess, use or disclose any Confidential Information of Discloser without Discloser’s prior written consent, and must use reasonable care to protect the Confidential Information. Recipient may only disclose Confidential Information to its employees and contractors who have a need to know for the purposes of this Agreement and who are bound by confidentiality obligations that are at least as protective as the provisions herein. Recipient will be responsible for any breach of confidentiality by its employees and contractors. Promptly after expiration of the Term (or, at Discloser’s request, at any time), Recipient must return all tangible Confidential Information, permanently erase all Confidential Information from any storage media and destroy all information, records and materials developed therefrom.

Legal Requirements: If Recipient receives a request to disclose any Confidential Information, whether pursuant to a valid subpoena or an order issued by a court or regulatory body (“Ordering Party”), and on advice of legal counsel such disclosure is required by law, then prior to disclosure, Recipient must (unless prohibited by law or such order) (a) notify Discloser of the terms of such request and advice, (b) cooperate with YData in taking lawful steps to resist, narrow, or eliminate the need for that disclosure, and (c) if disclosure is nonetheless required, work with Discloser to take into account Discloser’s reasonable requirements as to the timing, content and manner of disclosure and use best efforts to obtain a protective order or other binding assurance from the Ordering Party that confidential treatment will be afforded to the Confidential Information that is required to be disclosed. The foregoing is without limitation of Discloser’s ability to seek a protective order or other relief limiting such disclosure; in such a case, you must cooperate in such efforts by Discloser.

## **IP Rights**

Ownership of Data and Models: You are and will be the sole proprietor of the intellectual property rights in and to your data, any models resulting from the input of such data into the YData Software and any derivative materials of your data and models. Ownership of such data, models and derivatives does not transfer any rights in the YData Software to you.

Ownership of YData Software: Except for the limited rights and licenses expressly granted hereunder, no other license is granted (by implication, estoppel or otherwise), no other use is permitted, and YData (and its licensors) will retain all right, title and interest (including all patent rights, copyright rights, trade secret rights and all other intellectual property and proprietary rights) in and to the YData Software and Documentation and any derivative works thereof. The parties agree not to take any action inconsistent with the ownership as set forth herein.

Feedback: If you or any of your personnel provides any comments, criticisms, or other feedback relating to the YData Software (collectively, “Feedback”), you agree that: (a) Your Feedback becomes YData property, and you are not owed any compensation in exchange; (b) none of the Feedback contains confidential or proprietary information of any third party; (c) YData may use or redistribute Feedback for any purpose and in any way; (iv) there is no obligation for YData to review your Feedback; and (d) YData has no obligation to keep any Feedback confidential.

Your IP Developments; Non-Assertion and Waiver of Claims: You acknowledge and agree that this Agreement grants you a non-exclusive license, and YData uses the YData Software, and licenses third parties to use the YData Software, for purposes which may be similar to or the same as the purposes for which you use the YData Software, In the event you or your personnel develop any intellectual property, including any patents, copyrights, trade secrets and all other intellectual property or proprietary rights using the YData Software (the “Developed IP”), you agree that you will not assert the Developed IP against YData or its licensees in any action or claim for infringement or misappropriation should YData or any third party licensee develop any intellectual property which is similar to, or otherwise competes with, the Developed IP, and you hereby waive and release YData and its third party licensees from any and all such claims.

IP Markings: You may not (and may not permit any third party to) alter, obscure or remove any patent, trademark or other proprietary or legal notice deployed by or contained on any YData Software, Documentation or packaging.

Third Party Code: The YData Software may operate, interface or be delivered with software or other technology that is licensed from and owned by third parties (“Third Party Code”). You agree that (a) you will use Third Party Code in accordance with this Agreement (unless different terms are specified in the applicable license set forth or referenced in the Documentation), (b) no licensor of any Third Party Code makes any representation or warranty to you concerning the YData Software, and (c) no licensor of any Third Party Code will have any obligation or liability to you as a result of this Agreement or your use of the YData Software.

## **Disclaimer of Warranties**

NO WARRANTY. THE YDATA SOFTWARE AND DOCUMENTATION ARE PROVIDED “AS IS” WITHOUT WARRANTY OF ANY KIND. YDATA DOES NOT WARRANT THAT THE YDATA SOFTWARE WILL BE COMPATIBLE WITH ANY APPLICATION OR ENVIRONMENT OR OTHERWISE MEET YOUR REQUIREMENTS, OR THAT OPERATION WILL BE UNINTERRUPTED OR ERROR-FREE.

DISCLAIMER. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, ON BEHALF OF ITSELF AND ITS LICENSORS, YDATA HEREBY DISCLAIMS ALL WARRANTIES IN CONNECTION WITH THE YDATA SOFTWARE AND DOCUMENTATION, EXPRESS OR IMPLIED, ORAL OR WRITTEN, INCLUDING WITHOUT LIMITATION, ALL IMPLIED WARRANTIES OF TITLE, NON-INFRINGEMENT, INTEGRATION, ACCURACY, MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE AND ALL WARRANTIES ARISING FROM ANY COURSE OF DEALING OR PERFORMANCE OR USAGE OF TRADE.

STATE LAWS. IF THE LAW OF THE COUNTRY OR STATE WHERE YOU LIVE DOES NOT ALLOW THE DISCLAIMERS PROVIDED FOR IN THIS SECTION, THOSE DISCLAIMERS SHALL NOT APPLY TO YOU TO THE EXTENT PROHIBITED.

NO HIGH RISK ACTIVITIES. THE YDATA SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE IN CONNECTION WITH HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE PERFORMANCE, SUCH AS THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT NAVIGATION OR COMMUNICATIONS SYSTEMS, LIFE SUPPORT SYSTEMS, AND WEAPONS SYSTEMS, IN WHICH THE FAILURE OF SOFTWARE COULD LEAD TO PERSONAL INJURY AND DEATH (“HIGH RISK ACTIVITIES”). THE YDATA SOFTWARE MAY NOT BE USED FOR HIGH RISK ACTIVITIES.

## **Limitation of Liability**

INDIRECT DAMAGES. IN NO EVENT SHALL YDATA BE LIABLE TO YOU OR ANY OTHER USER OF THE YDATA SOFTWARE CONCERNING THE SUBJECT MATTER OF THIS AGREEMENT, REGARDLESS OF THE FORM OF ANY CLAIM OR ACTION (WHETHER IN CONTRACT, NEGLIGENCE, STRICT LIABILITY OR OTHERWISE), FOR ANY (A) LOSS OR INACCURACY OF DATA, LOSS OR INTERRUPTION OF USE, OR COST OF PROCURING SUBSTITUTE TECHNOLOGY, GOODS OR SERVICES, OR (B) INDIRECT, PUNITIVE, INCIDENTAL, RELIANCE, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES INCLUDING, BUT NOT LIMITED TO, LOSS OF BUSINESS, REVENUES, PROFITS OR GOODWILL.

DIRECT DAMAGES. OUR AGGREGATE LIABILITY FOR ALL CLAIMS ARISING FROM THESE TERMS SHALL NOT EXCEED THE GREATER OF (A) $100.00 OR (B) THE AGGREGATE AMOUNT YOU HAVE PAID TO YDATA IN FEES FOR THE YDATA SOFTWARE GIVING RISE TO SUCH DAMAGES DURING THE 12-MONTH PERIOD PRIOR TO THE DATE THE CAUSE OF ACTION AROSE, EVEN IF YOU HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THESE LIMITATIONS ARE INDEPENDENT FROM ALL OTHER PROVISIONS OF THIS AGREEMENT AND WILL APPLY NOTWITHSTANDING THE FAILURE OF ANY REMEDY PROVIDED HEREIN

STATE EXCLUSIONS. SOME STATES DO NOT ALLOW THE EXCLUSION OR LIMITATION OF INCIDENTAL OR CONSEQUENTIAL DAMAGES, SO THE ABOVE LIMITATIONS AND EXCLUSIONS MAY NOT APPLY TO YOU.

RELIANCE. YDATA ACKNOWLEDGES AND AGREES THAT YDATA HAS OFFERED THE YDATA SOFTWARE AND ENTERED INTO THESE TERMS IN RELIANCE UPON THE DISCLAIMERS, LIMITATIONS OF LIABILITY, INDEMNITY, AND OTHER TERMS LIMITING OR ELIMINATING YDATA’s EXPOSURE TO RISK. YOU FURTHER ACKNOWLEDGE AND AGREE THAT ALL SUCH TERMS SET FORTH IN THESE TERMS REFLECT A REASONABLE AND FAIR ALLOCATION OF RISK BETWEEN YOU AND YDATA, AND THAT THE FOREGOING FORM AN ESSENTIAL BASIS OF THE BARGAIN BETWEEN YOU AND YDATA. BUT FOR THE FOREGOING, YDATA WOULD NOT AGREE TO PROVIDE THE YDATA SOFTWARE AND DOCUMENTATION TO YOU.

## **Indemnity**

You shall indemnify, defend and hold harmless YData and its officers, directors, employees and agents, at your expense, from any claims, damages, losses, liabilities and all costs and expenses of defense, including, without limitation, attorneys’ fees, resulting directly or indirectly from a claim by a third party that arises in connection with your legal, illegal, authorized, or unauthorized use of the YData Software. You shall not accept any settlement that (a) imposes an obligation on YData; (b) requires YData to make an admission; or (c) imposes liability not covered by these indemnifications or places restrictions on YData without YData’s prior written consent.

## **Dispute Resolution**

YOU AND YDATA AGREE TO THE FOLLOWING MANDATORY ARBITRATION AND CLASS ACTION WAIVER PROVISIONS:

General. Except for disputes relating to your or YData’s intellectual property, you agree that all disputes between you and YData (whether or not such dispute involves a third party) arising out of or relating to this Agreement, the YData Software, or YData’s Privacy Policy shall be finally resolved by arbitration conducted in the English language in Seattle, Washington, U.S.A. under the Commercial Arbitration Rules of the American Arbitration Association (“AAA”), and you and YData hereby expressly waive trial by jury. You and YData shall appoint one arbitrator mutually agreed upon or, if you and YData cannot agree within thirty (30) days of either party’s request for arbitration, such arbitrator shall be selected by the AAA upon the request of either party. The parties shall bear equally the cost of the arbitration (except that the prevailing party shall be entitled to an award of reasonable attorneys’ fees incurred in connection with the arbitration in such an amount as may be determined by the arbitrator). All decisions of the arbitrator shall be final and binding on both parties and enforceable in any court of competent jurisdiction. Notwithstanding this, application may be made to any court for a judicial acceptance of the award or order of enforcement. Under no circumstances shall the arbitrator be authorized to award damages, remedies or awards that conflict with this Agreement.

Right to Opt Out. You may opt out of this agreement to arbitrate. If you do so, neither you nor YData can require the other to participate in an arbitration proceeding. To opt out, you must notify YData in writing within thirty (30) days after the date that you first became subject to this arbitration provision. The opt out notice must state that you do not agree to the agreement to arbitrate and must include your name, address and phone number to which the opt out applies and a clear statement that you want to opt out of this agreement to arbitrate. You must sign the opt out notice for it to be effective. This procedure is the only way you can opt out of this agreement to arbitrate. You must use this address to opt out: 92 Lenora street, Suite 165, Seattle, WA 98121\.

Changes, Survival. Notwithstanding any provision in this Agreement to the contrary, you and YData agree that if YData makes any change to the arbitration procedures set forth in this Agreement (other than a change to any notice address or Site link provided herein) in the future, that change shall not apply to any claim that was filed in a legal proceeding prior to the effective date of the change. Moreover, if YData seeks to terminate the arbitration procedures from this Agreement, such termination shall not be effective until thirty (30) days after the version of this Agreement not containing the arbitration procedures is posted to the Site, and shall not be effective as to any claim that was filed in a legal proceeding prior to the effective date of removal. This agreement to arbitrate will survive the termination of your relationship with YData.

## **General Terms**

Marketing and Promotion. You agree that YData may mention your associated entity and use its logo within its promotional and marketing material.

Export Restrictions. The YData Software and underlying information or technology may not be accessed or otherwise exported or re-exported (a) into any country to which the U.S. has embargoed goods, or (b) to anyone on the U.S. Treasury Department’s List of Specially Designated Nationals or the U.S. Commerce Department’s Table of Denial Orders. You represent and warrant that you are not located in, under the control of, or a national or resident of any such country or on any such list.

Entire Agreement. This Agreement contains the entire understanding of the parties with respect to the transactions and matters contemplated herein, supersedes all previous communications, understandings and agreements (whether oral or written) and cannot be amended except by a writing signed by both parties or by YData’s posting of an amended version of this Agreement on the Site. However, if you or the entity for which you are accessing and using the YData Software have a separate binding written agreement in place with YData with respect to the YData Software, that separate agreement shall take precedence over this Agreement in the event of a conflict.

No Assignment. You may not assign or transfer your rights or obligations under this Agreement in whole or in part to any third party without YData’s written consent.

Binding Effect. These Terms shall bind and inure to the benefit of the parties to this Agreement and their respective successors, permitted transferees and permitted assigns.

Independent Contractors. YData and you are independent contractors and are not partners, joint venturers, agents, employees or representatives of the other party.

Severability. If any provision of this Agreement is determined to be illegal or unenforceable, that provision will be limited or eliminated to the minimum extent necessary so that this Agreement will otherwise remain in full force and effect and enforceable.

English Language. These Terms are in English only, which will be controlling in all respects. No version of this Agreement in another language will be binding or of any effect.

Waiver. The failure of YData to exercise or enforce any right or provision of this Agreement shall not constitute a waiver of such right or provision.

Governing Law. These Terms will be governed by and construed in accordance with the laws of the Commonwealth of Washington, without regard to its conflicts of law provisions. The United Nations Convention on Contracts for the International Sale of Goods and the Uniform Computer Information Transactions Act will not apply to this Agreement.

Venue. Each party hereby irrevocably submits to the exclusive jurisdiction of the state courts located in King County, Washington (or, if there is federal jurisdiction, the United Stated District Court) for the determination of any action arising out of or in connection with this Agreement. Notwithstanding the foregoing, YData may commence appropriate legal action in any jurisdiction to protect the YData Software or Confidential Information.

No Class Action. Any claims brought by you or YData must be brought in that party’s individual capacity, and not as a plaintiff or class member in any purported class or representative proceeding. Neither you nor YData will participate in a class action for any claims covered by this Agreement. You hereby waive any and all rights to bring any claims related to this Agreement and the Privacy Policy as a plaintiff or class member in any purported class or representative proceeding. You may bring claims only on your own behalf.

Remedies Cumulative. Unless specifically provided otherwise, each right and remedy in this Agreement is in addition to any other right or remedy, at law or in equity.

Injunctive Relief. You agree that, in the event of any breach or threatened breach of confidentiality, license grant or restrictions or proprietary rights, YData will suffer irreparable damage for which there is no adequate remedy at law. Accordingly, YData will be entitled to injunctive and other equitable remedies to prevent or restrain such breach or threatened breach, without the necessity of posting any bond.

Notices. Any notice or communication hereunder must be in writing and either personally delivered, or sent via confirmed electronic mail to legal@ydata.ai, or sent via recognized express delivery courier or certified or registered mail, prepaid and return receipt requested, addressed to the other party at its address 92 Lenora street, suite 165, Seattle, WA 98121, or at such other address designated in a subsequent notice. All notices must be in English, effective upon receipt.

US Government Rights. If any user of the YData Software or Documentation is a department, agency or other entity of the U.S. Government, then use, duplication, reproduction, modification, release, disclosure or transfer of the YData Software and Documentation is restricted in accordance with FAR 12.212 for civilian agencies and DFAR 227.7202 for military agencies. The YData Software is commercial computer software and the Documentation is commercial computer software documentation, and their use is further restricted in accordance with the terms of this Agreement.

Survival. Accrued obligations and all provisions of this Agreement that by their nature should survive will survive any termination of this Agreement.

Acknowledgement. You acknowledge that (a) you have read and understand this Agreement, (b) you have had an opportunity to have legal counsel review this Agreement, (c) this Agreement has the same force and effect as a signed agreement, even if it is agreed by click-through or provided by cross-reference only, and (d) issuance of this license does not constitute general publication of the YData Software, Documentation or Confidential Information.